typedef unsigned char  u8;
typedef   signed char  s8;
typedef unsigned short u16;
typedef   signed short s16;
typedef unsigned long  u32;
typedef   signed long  s32;


#define XTAL    11059200UL              // 11.0592MHz
#define INTTIME         (XTAL / 8 / 256)        // interrupt time


#define _A      0x08                            //segment order
#define _B      0x10
#define _C      0x80
#define _D      0x40
#define _E      0x20
#define _F      0x04
#define _G      0x02
#define _DP     0x01                            //decimal point

#define _0      ( _A+_B+_C+_D+_E+_F    )        //number pattern
#define _1      (    _B+_C             )
#define _2      ( _A+_B+   _D+_E+   _G )
#define _3      ( _A+_B+_C+_D+      _G )
#define _4      (    _B+_C+      _F+_G )
#define _5      ( _A+   _C+_D+   _F+_G )
#define _6      ( _A+   _C+_D+_E+_F+_G )
#define _7      ( _A+_B+_C             )
#define _8      ( _A+_B+_C+_D+_E+_F+_G )
#define _9      ( _A+_B+_C+_D   +_F+_G )



int main(void)
{
  for(;;){

  }
}


u16 sec_timer;

u8 minute, hour;

u8 digit[4];

u8 numbers[] = { _0, _1, _2, _3, _4, _5, _6, _7, _8, _9 };


u8 get7s( u8 val )
{
  return numbers[val];
}


void display_time( u8 set )
{
  u8 t = sec_timer >> 8;		// high byte only

  if( t < (INTTIME >> 9) )		// 1/2 second
    set = 0;

  if( set == 1 ){
    digit[3] = 0;
    digit[2] = 0;
  }else{
    digit[3] = get7s( hour / 10);
    digit[2] = get7s( hour % 10);
  }
  if( set == 2 ){
    digit[1] = 0;
    digit[0] = 0;
  }else{
    digit[1] = get7s( minute / 10);
    digit[0] = get7s( minute % 10);
  }
}
